From rice!husc6!purdue!spaf Mon May 15 16:00:47 CDT 1989
Article 261 of news.announce.newusers:
Path: rice!husc6!purdue!spaf
>From: spaf@cs.purdue.EDU (Gene Spafford)
Newsgroups: news.admin,news.announce.newusers
Subject: USENET Software: History and Sources (Updated: 14 May 1989)
Message-ID: <6752@medusa.cs.purdue.edu>
Date: 15 May 89 03:56:41 GMT
Expires: 13 Aug 89 03:56:40 GMT
Followup-To: news.admin
Organization: Dept. of Computer Sciences, Purdue Univ.
Lines: 219
Approved: spaf@cs.purdue.EDU
Supersedes: <6481@medusa.cs.purdue.edu>
Xref: rice news.admin:4822 news.announce.newusers:261

Original from: spaf@purdue (Gene Spafford)
[Most recent change: 14 May 1989 by Gene Spafford <spaf@cs.purdue.edu>]


Currently, Usenet readers interact with the news using a number of
software packages and programs.  This article mentions the important
ones and a little of their history, gives pointers where you can look
for more information and ends with some special notes about "foreign"
and "obsolete" software.  At the very end is a list of sites from which
current versions of the Usenet software may be obtained.

History
-------
Usenet came into being in late 1979, shortly after the release of V7
Unix with UUCP.  Two Duke University grad students in North Carolina,
Tom Truscott and Jim Ellis, thought of hooking computers together to
exchange information with the Unix community.  Steve Bellovin, a grad
student at the University of North Carolina, put together the first
version of the news software using shell scripts and installed it on
the first two sites: "unc" and "duke." At the beginning of 1980 the
network consisted of those two sites and "phs" (another machine at
Duke), and was described at the January Usenix conference.  Steve
Bellovin later rewrote the scripts into C programs, but they were never
released beyond "unc" and "duke." Shortly thereafter, Steve Daniel did
another implementation in C for public distribution.  Tom Truscott made
further modifications, and this became the "A" news release.

In 1981 at U. C. Berkeley, grad student Mark Horton and high school
student Matt Glickman rewrote the news software to add functionality
and to cope with the ever increasing volume of news -- "A" news was
intended for under 100 sites and only a few articles per group per
day.  This rewrite was the "B" news version.  The first public release
was version 2.1 in 1982; the 1.* versions were all beta test.  As the
net grew, the news software was expanded and modified.  The last
version maintained and released primarily by Mark was 2.10.1.

Rick Adams, at the Center for Seismic Studies, took over coordination
of the maintenance and enhancement of the news software with the 2.10.2
release in 1984.  By this time, the increasing volume of news was
becoming a concern, and the mechanism for moderated groups was added to
the software at 2.10.2.  Moderated groups were inspired by ARPA mailing
lists and experience with other bulletin board systems.  In late 1986,
version 2.11 of news was released, including a number of changes to
support a new naming structure for newsgroups, enhanced batching and
compression,  enhanced ihave/sendme control messages, and other features.

The current release of news is 2.11, patchlevel 17, dated Feb 1989.
Article format is specified in RFC 1036, last revised in December 1987 (a
version is distributed with the news software). 
   {An aside about RFCs:  a RFC is a Request For Comment, a de-facto
   standard in the Internet Community.  It is a form of published
   software standard, done through the Network Information Center (NIC)
   at SRI.  Copies of RFCs are often posted to the net and obtainable
   from archive sites.}

A new version of news, becoming known as "C" news, has been developed
at the University of Toronto by Geoff Collyer and Henry Spencer.  This
version is a rewrite of the lowest levels of news to increase article
processing speed, decrease article expiration processing and improve
the reliability of the news system through better locking, etc.  The
package was released to the net in the autumn of 1987.  For more
information, see the paper "News Need Not Be Slow," published in The
Winter 1987 Usenix Technical Conference proceedings.

Two popular screen-oriented news reading interfaces have been developed
in the last few years to replace the traditional "readnews" interface.
The first of these was "vnews" and it was written by Kenneth Almquist.
"vnews" provides a "readnews"-like command interface, but displays
articles using direct screen positioning.  It appears to have been
inspired, to some extent, by the "notes" system (described below).
"vnews" is currently distributed with the standard 2.11 news source.

A second, more versatile interface, "rn", was developed by Larry Wall
now of JPL/NASA and released in 1984.  This interface also uses
full-screen display with direct positioning, but it includes many other
useful features and is very popular with many regular net readers. The
interface includes reading, discarding, and/or processing of articles
based on user-definable patterns, the ability to follow "threads of
discussions" in newsgroups, and the ability of the user to develop
customized macros for display and keyboard interaction.  "rn" is
currently at release 4.3, patchlevel 40, with a major re-release under
development.  "rn" is not provided with the standard news software
release, but is very widely available due to its popularity.

"notes" is a software package popular at some sites.  It uses a
different internal organization of articles, and a different
interchange format than that of the standard Usenet software.  It was
inspired by the notesfiles available in the PLATO system and was
developed independently from the Usenet news.  Eventually, the "notes"
network and Usenet were joined via gateways doing (sometimes imperfect)
protocol translation. The interface for "notes" is similar to "rn" but
implements different features, many of which are dictated by its
internal organization.  "notes" was written in 1980-1981 by Ray Essick
and Rob Kolstad, (then) grad students at the University of Illinois at
Urbana-Champaign.  The first public release of "notes" was at the
January 1982 Usenix conference.  The current release of notes is
version 1.7.

In March 1986 a package was released implementing news transmission,
posting, and reading using the Network News Transfer Protocol (NNTP)
(as specified in RFC 977).  This protocol allows hosts to exchange
articles via TCP/IP connections rather than using the traditional
uucp.  It also permits users to read and post news (using a modified
version of "rn" or other user agents) from machines which cannot or
chose not to install the USENET news software.  Reading and posting are
done using TCP/IP messages to a server host which does run the USENET
software.  Sites which have many workstations like the Sun and Apollo
products find this a convenient way to allow workstation users to read
news without having to store articles on each system.  Many of the
Usenet hosts that are also on the Internet exchange news articles using
NNTP because the load impact of NNTP is much lower than uucp (and NNTP
ensures much faster propagation).

NNTP grew out of independent work in 1984-1985 by Brian Kantor at U.
C.  San Diego and Phil Lapsley at U. C. Berkeley.  It is now in
release 1.5, and includes support for System V UNIX with Excelan
Ethernet cards and DECNET under Ultrix.  NNTP was developed at U. C.
Berkeley by Phil Lapsley with help from Erik Fair, Steven Grady, and
Mike Meyer, among others.  The NNTP package is distributed on the
4.3BSD release tape (although that is version 1.2a and out-of-date)
and is also available from the various authors, many major hosts, and
by anonymous FTP from ucbvax, ucsd, and gatech.  Reader clients for
VMS systems should be available soon.  A TOPS-20 reader was developed
by Dave Edwards of SRI <dle@kl.sri.com>, but current availability is
unknown.  There is also an NNTP-based netnews reader for Symbolics
Lisp Machines (under Genera 7) available for anonymous FTP from
ucbvax.berkeley.edu [10.2.0.78] in pub/nntp-clients/lispm written by
Ian Connolly <connolly@coins.cs.umass.edu> and maintained by Richard
Welty <welty@lewis.crd.ge.com>.  An NNTP reader suite for PC's running
MS-DOS and having Excelan boards is available for ftp from
ames.arc.nasa.gov; get the pcrrn files.

At least one IBM VM/SP (CMS) version of the Usenet software is
available.  Interested parties should contact Irwin Tillman of
Princeton University (irwin@pucc.princeton.edu or irwin@pucc.bitnet)
for details.  Another version may also be available from Bill Verity at
Penn State (whv@psuvm.bitnet).

A VAX/VMS implementation is available that implements a screen-based
user interface with the functionality similar to rn. The program allows
reading, posting, direct replies, moderated newsgroups, etc.  in a
fashion closely related to regular news.  The implementation includes
the RFC1036 news propagation algorithms and integrated use of the NNTP
protocols to support remote news servers, implemented as a VAX/VMS
Decnet object.  A RFC977 server implemented as a Decnet object is also
included.  The license for the software is free, and there are no
restrictions on the re-distribution.  For more info, contact
gih900@fac.anu.oz.au (Geoff Huston).


Special note on "notes" and pre-2.11 news
-----------------------------------------
Users of these systems may note problems in their interactions with the
Usenet.  In particular, postings may be made by "notes" users to
moderated groups but they will not usually propagate throughout the
entire Usenet.  The same may happen to users of old B news software.

Users of "notes" or old B news software wishing to post to moderated
groups should either mail their submissions to the moderator, as listed
in the monthly posting of "List of Moderators" in the group
"news.lists", or else they should post from a system running up-to-date
B news software (i.e., 2.11).  "notes" users may obtain some patches
from the comp.sources.unix archives which enable recent versions of
"notes" to interact with moderated groups properly.

Users of old B news and "notes" are also not able to take advantage of
some other current B news features, such as the "checkgroups" message.
"notes" continues to be a "foreign" system, and B news versions before
2.10.2 are considered "obsolete."  The various maintainers of the
Usenet software have never expressed any commitment to maintain
backwards compatibility with "foreign" or obsolete news systems and are
unlikely to do so;  it is the responsibility of the users to maintain
compatibility of such software if they wish to continue to interact
with the Usenet.


Software versions & availability
--------------------------------
You can obtain the version number of your news software by issuing the
"v" command in either "vnews" or "readnews."  "rn" version is
obtainable by typing the "v" command to the top level prompt -- it
should currently be 4.3.1.4.

Current software is obtainable from almost any major Usenet site.
Source to the 'rn' newsreader program is also widely available.

The following sites have sources to the current news software available
for anyone needing a copy:

		Site		Contact
		----		-------
		gatech		gatech!usenet
		killer		killer!postmaster
		ncar		ncar!woods
		mirror		mirror!usenet
		munnari		munnari!kre
		osu-cis		osu-cis!bob
		philabs		philabs!usenet
		pyramid		pyramid!usenet
		rutgers		rutgers!usenet
		tektronix	tektronix!news
		ulowell		ulowell!usenet
		watmath		watmath!usenet

Sources for both news 2.11 and "rn" are also available in the
comp.sources.unix archives.  European sites should request the sources
from their nearest Eunet backbone site.

Acknowledgements
----------------
The preparation of this article (and Usenet itself!) was greatly
enhanced by the contributions and assistance of the following persons:
Steve Bellovin, Ray Essick, Mark Horton, Brian Kantor, Phil Lapsley,
Bob Page, Tom Truscott, and Larry Wall.  Thanks, folks.
-- 
Gene Spafford
NSF/Purdue/U of Florida  Software Engineering Research Center,
Dept. of Computer Sciences, Purdue University, W. Lafayette IN 47907-2004
Internet:  spaf@cs.purdue.edu	uucp:	...!{decwrl,gatech,ucbvax}!purdue!spaf


