From: spaf@cs.purdue.EDU (Gene Spafford)
Newsgroups: news.lists,news.groups,news.announce.newusers
Subject: List of Active Newsgroups (Updated: 11 September 1988)
Message-ID: <5062@medusa.cs.purdue.edu>
Date: 11 Oct 88 02:55:50 GMT
Expires: +90days
Organization: Dept. of Computer Sciences, Purdue Univ.
Lines: 463
Approved: spaf@cs.purdue.EDU
Supersedes: <4842@medusa.cs.purdue.edu>
Xref: rice news.lists:257 news.groups:3607 news.announce.newusers:184

[Most recent change: 19 June 1989 by spaf@cs.purdue.edu (Gene Spafford)]

The following is a list of currently active USENET newsgroups as of
10 October 1988.  The groups distributed worldwide are divided 
into seven broad classifications:  "news", "soc", "talk", "misc",
"sci", "comp" and "rec".  Each of these classifications is organized
into groups and subgroups according to topic.

"comp"  Topics of interest to both computer professionals and
	hobbyists, including topics in computer science, software
	source, and information on hardware and software systems.

"sci"   Discussions intended as technical in nature and relating
	to the established sciences.

"misc"  Groups addressing themes not easily classified under any of the
	other headings or which incorporate themes from multiple
	categories.

"soc"	Groups primarily addressing social issues and socializing.

"talk"	Groups largely debate-oriented and tending to feature long
	discussions without resolution and without appreciable amounts
	of generally useful information.

"news"	Groups concerned with the news network and software themselves.

"rec"	Groups oriented towards hobbies and recreational activities.

These "world" newsgroups are (usually) circulated around the entire
USENET -- this implies world-wide distribution.  Not all groups
actually enjoy such wide distribution, however.  The European Usenet
and Eunet sites take only a selected subset of the more "technical"
groups, and controversial "noise" groups are often not carried by many
sites in the US and Canada (these groups are primarily under the "talk"
and "soc" classifications).  Many sites do not carry some or all of
the comp.binaries groups.

There are groups in other subcategories, but they are local: to
institutions, to geographic regions, etc. and they are not listed
here.  Note that these distribution categories can be used to restrict
the propagation of news articles.  Currently, distributions include:
	world		worldwide distribution (default)
	att		limited to AT&T
	can		limited to Canada
	eunet		limited to European sites
	na		limited to North America
	usa		limited to the United States
There may be other regional and local distribution categories available
at your site.  Most US states have distribution categories named after
the two letter abbreviation for that state or category (e.g., "ga" for
Georgia, "nj" for New Jersey). Please use an appropriate distribution
category if your article is not likely to be of interest to USENET
readers worldwide.

Some groups are moderated or are monitored mailing lists.  They can
only be posted to by mailing submissions to the coordinator (provided
in a companion posting).  Some selected sites provide automatic
remailing in support of 2.11 news -- posting to one of these groups
automatically mails the article for the poster. Some of the moderated
groups are gatewayed to USENET from the ARPA Internet and appear as
newsgroups to facilitate distribution and posting from the Usenet.
Other of the "world" groups are bidirectionally gatewayed with ARPA
Internet mailing lists; items submitted from the ARPA side to the
digest are split up and submitted to the USENET group, while articles
submitted on the USENET side are bundled up and submitted to the
mailing list.  A complete list of moderated newsgroups, submission
addresses and moderators is given in a companion posting.

The following "world" groups have been gatewayed with the listed
Arpa Internet lists.  Some of them may not still be gatewayed due to
broken software and/or gateways; such groups are marked with an
asterisk ("*") in the list below.  Please contact me if you should know
of their current status.  Also note that the group "comp.lang.forth" is
gatewayed with the Bitnet discussion list "umforth@weizmann.bitnet", and
rec.railroad is run from "railroad@queens.bitnet".
Some of these lists are gated one-way into Usenet groups; those groups
have been marked with a ">" symbol in the list below.

If you are reading this article from a site not on the Usenet, you may
subscribe to Arpa Internet lists by writing to the request address.
You form such an address by putting "-request" before the "@" symbol,
as in "unix-emacs-request@bbn.com".  This gets your message directly to
the list maintainer instead of broadcasting it to all the readers of
the list.

Also note that moderators of Usenet groups may not be in charge of the
corresponding mailing list or gateway.  For example, the moderator of
comp.sources.unix does not have anything to do with the unix-sources
mailing list; matters concerning the mailing list should be addressed
to unix-sources-request@brl.arpa

	Usenet Group		Arpa Internet list
	------------		----------------
	comp.dcom.modems	info-modems@wsmr-simtel20.army.mil
	comp.emacs		unix-emacs@bbn.com
   	>comp.emacs		info-gnu-emacs@prep.ai.mit.edu
	*comp.lang.ada		info-ada@ajpo.sei.cmu.edu
	comp.lang.c		info-c@brl.arpa
 	>comp.lang.c++		info-g++@prep.ai.mit.edu
	comp.lang.modula2	info-m2@ucf1vm.bitnet
	*comp.lang.pascal	info-pascal@brl.arpa
	*comp.lang.prolog	prolog@score.stanford.edu
	comp.os.cpm		info-cpm@wsmr-simtel20.army.mil
	comp.os.minix		info-minix@udel.edu
	comp.protocols.kerberos	kerberos@athena.mit.edu
        comp.protocols.nfs      nfs@tmc.edu
	comp.sys.apple		info-apple@brl.arpa
	comp.sys.atari.8bit	info-atari8@score.stanford.edu
	comp.sys.atari.st	info-atari16@score.stanford.edu
	comp.sys.misc		info-micro@wsmr-simtel20.army.mil
	comp.sys.sun		sun-spots@rice.edu
	comp.sys.tahoe		info-tahoe@csd1.milw.wisc.edu
	comp.sys.xerox		info-1100@tut.cis.ohio-state.edu
	>comp.text		texhax@cs.washington.edu
	*comp.terminals		info-terms@mc.lcs.mit.edu
	comp.unix.questions	info-unix@brl.arpa
	comp.unix.wizards	unix-wizards@brl.arpa
	comp.windows.x		xpert@expo.lcs.mit.edu
        rec.ham-radio           info-hams@wsmr-simtel20.army.mil
        rec.ham-radio.packet    packet-radio@wsmr-simtel20.army.mil
	rec.music.gdead		dead-flames@ms.lcs.mit.edu
        rec.video               videotech@wsmr-simtel20.army.mil
	*sci.astro		sky-fans@xx.lcs.mit.edu
	sci.physics		physics@unix.sri.com
	*sci.space		space@angband.s1.gov
	*talk.origins		evolution@kestrel.arpa
	rec.equestrian		horse@bbn.com
	*rec.ham-radio		info-hams@simtel20.arpa
	rec.ham-radio.packet	packet-radio@eddie.mit.edu
	rec.arts.sf-lovers	sf-lovers@rutgers.edu
	*rec.video		videotech@simtel20.arpa
	comp.sources.misc	unix-sources@brl.arpa
	comp.sources.unix	unix-sources@brl.arpa

Please notify me of any errors or changes to this article.

Gene Spafford
spaf@purdue.EDU
----------------------------------------------------------------------
Newsgroup		Description
----------------------------------------------------------------------
comp.ai			Artificial intelligence discussions.
comp.ai.shells		Artificial intelligence applied to shells. (Moderated)
comp.ai.digest		Artificial Intelligence discussions. (Moderated)
comp.ai.neural-nets	All aspects of neural networks.
comp.ai.nlang-know-rep	Natural Language and Knowledge Representation. (Moderated)
comp.arch		Computer architecture.
comp.archives		Descriptions of public access archives. (Moderated)
comp.binaries.amiga	Encoded public domain programs in binary. (Moderated)
comp.binaries.apple2	Binary-only postings for the Apple II computer.
comp.binaries.atari.st	Binary-only postings for the Atari ST. (Moderated)
comp.binaries.ibm.pc	Binary-only postings for IBM PC/MS-DOS. (Moderated)
comp.binaries.ibm.pc.d	Discussions about IBM/PC binary postings.
comp.binaries.mac	Encoded Macintosh programs in binary. (Moderated)
comp.bugs.2bsd		Reports of UNIX* version 2BSD related bugs.
comp.bugs.4bsd		Reports of UNIX version 4BSD related bugs.
comp.bugs.4bsd.ucb-fixes	Bug reports/fixes for BSD Unix. (Moderated)
comp.bugs.misc		General UNIX bug reports and fixes (incl V7, uucp)
comp.bugs.sys5		Reports of USG (System III, V, etc.) bugs.
comp.cog-eng		Cognitive engineering.
comp.compilers		Compiler construction, theory, etc. (Moderated)
comp.databases		Database and data management issues and theory.
comp.dcom.lans		Local area network hardware and software.
comp.dcom.modems	Data communications hardware and software.
comp.dcom.telecom	Telecommunications digest. (Moderated)
comp.doc		Archived public-domain documentation. (Moderated)
comp.doc.techreports	Lists of technical reports. (Moderated)
comp.edu		Computer science education.
comp.emacs		EMACS editors of different flavors.
comp.fonts		Typefonts -- design, conversion, use, etc.
comp.graphics		Computer graphics, art, animation, image processing.
comp.graphics.digest	Graphics software, hardware, theory, etc. (Moderated)
comp.ivideodisc		Interactive videodiscs -- uses, potential, etc.
comp.lang.ada		Discussion about Ada*.
comp.lang.apl		Discussion about APL.
comp.lang.c		Discussion about C.
comp.lang.c++		The object-oriented C++ language.
comp.lang.eiffel	The object-oriented Eiffel language.
comp.lang.forth		Discussion about Forth.
comp.lang.fortran	Discussion about FORTRAN.
comp.lang.lisp		Discussion about LISP.
comp.lang.misc		Different computer languages not specifically listed.
comp.lang.modula2	Discussion about Modula-2.
comp.lang.pascal	Discussion about Pascal.
comp.lang.postscript	The PostScript Page Description Language.
comp.lang.prolog	Discussion about PROLOG.
comp.lang.scheme	The Scheme Programming language.
comp.lang.sigplan	Info & announcements from ACM SIGPLAN. (Moderated)
comp.lang.smalltalk	Discussion about Smalltalk 80.
comp.laser-printers	Laser printers, hardware & software. (Moderated)
comp.lsi		Large scale integrated circuits.
comp.mail.elm		Discussion and fixes for ELM mail system. 
comp.mail.headers	Gatewayed from the ARPA header-people list.
comp.mail.maps		Various maps, including UUCP maps. (Moderated)
comp.mail.mh		The UCI version of the Rand Message Handling system.
comp.mail.misc		General discussions about computer mail.
comp.mail.mush		The Mail User's Shell (MUSH).
comp.mail.sendmail	Configuring and using the BSD sendmail agent.
comp.mail.uucp		Mail in the uucp network environment.
comp.misc		General topics about computers not covered elsewhere.
comp.newprod		Announcements of new products of interest. (Moderated)
comp.org.decus		DEC* Users' Society newsgroup.
comp.org.fidonet	FidoNews digest, official news of FidoNet Assoc. (Moderated)
comp.org.ieee		Issues and announcements about the IEEE & its members.
comp.org.usenix		USENIX Association events and announcements.
comp.org.usrgroup	News/discussion about/from the /usr/group organization.
comp.os.cpm		Discussion about the CP/M operating system.
comp.os.eunice		The SRI Eunice system.
comp.os.minix		Discussion of Tanenbaum's MINIX system.
comp.os.misc		General OS-oriented discussion not carried elsewhere.
comp.os.os9		Discussions about the os9 operating system.
comp.os.research	Operating systems and related areas. (Moderated)
comp.os.vms		DEC's VAX* line of computers & VMS.
comp.os.xinu		The XINU operating system from Purdue (D. Comer).
comp.parallel		Massively parallel hardware/software. (Moderated)
comp.periphs		Peripheral devices.
comp.protocols.appletalk	Applebus hardware & software.
comp.protocols.ibm	Networking with IBM mainframes.
comp.protocols.iso	The ISO protocol stack.
comp.protocols.kerberos	The Kerberos authentification server.
comp.protocols.kermit	Info about the Kermit package. (Moderated)
comp.protocols.misc	Various forms and types of FTP protocol.
comp.protocols.nfs	Discussion about the Network File System protocol.
comp.protocols.tcp-ip	TCP and IP network protocols.
comp.protocols.tcp-ip.ibmpc	TCP/IP for IBM(-like) personal computers.
comp.realtime		Issues related to real-time computing.
comp.risks		Risks to the public from computers & users. (Moderated)
comp.simulation		Simulation methods, problems, uses. (Moderated)
comp.society		The impact of technology on society. (Moderated)
comp.society.futures	Events in technology affecting future computing.
comp.society.women	Women's roles and problems in computing (Moderated)
comp.software-eng	Software Engineering and related topics.
comp.sources.amiga	Source code-only postings for the Amiga. (Moderated)
comp.sources.atari.st	Source code-only postings for the Atari ST. (Moderated)
comp.sources.bugs	Bug reports, fixes, discussion for posted sources
comp.sources.d		For any discussion of source postings.
comp.sources.games	Postings of recreational software. (Moderated)
comp.sources.games.bugs	Bug reports and fixes for posted game software.
comp.sources.mac	Software for the Apple Macintosh. (Moderated)
comp.sources.misc	Posting of software . (Moderated)
comp.sources.sun	Software for Sun workstations. (Moderated)
comp.sources.unix	Postings of complete, UNIX-oriented sources. (Moderated)
comp.sources.wanted	Requests for software and fixes.
comp.sources.x		Software for the X windows system. (Moderated)
comp.std.c		Discussion about C language standards.
comp.std.internat	Discussion about international standards.
comp.std.misc		Discussion about various standards.
comp.std.mumps		Discussion for the X11.1 committee on Mumps. (Moderated)
comp.std.unix		Discussion for the P1003 committee on UNIX. (Moderated)
comp.sw.components	Software components and related technology.
comp.sys.amiga		Commodore Amiga: info&uses, but no programs.
comp.sys.amiga.tech	Technical discussion about the Amiga.
comp.sys.apollo		Apollo computer systems.
comp.sys.apple		Discussion about Apple micros.
comp.sys.atari.8bit	Discussion about 8 bit Atari micros.
comp.sys.atari.st	Discussion about 16 bit Atari micros.
comp.sys.att		Discussions about AT&T microcomputers.
comp.sys.cbm		Discussion about Commodore micros.
comp.sys.celerity	Celerity Computers
comp.sys.dec		Discussions about DEC computer systems.
comp.sys.dec.micro	DEC Micros (Rainbow, Professional 350/380)
comp.sys.encore		Encore's MultiMax computers.
comp.sys.hp		Discussion about Hewlett-Packard equipment.
comp.sys.ibm.pc		Discussion about IBM personal computers.
comp.sys.ibm.pc.digest	The IBM PC, PC-XT, and PC-AT. (Moderated)
comp.sys.ibm.pc.rt	Topics related to IBM's RT computer.
comp.sys.intel		Discussions about Intel systems and parts.
comp.sys.isis		The ISIS distributed system from Cornell.
comp.sys.m6809		Discussion about 6809's.
comp.sys.m68k		Discussion about 68k's.
comp.sys.m68k.pc	Discussion about 68k-based PCs. (Moderated)
comp.sys.mac		Discussions about the Apple Macintosh & Lisa.
comp.sys.mac.digest	Apple Macintosh: info&uses, but no programs. (Moderated)
comp.sys.mac.hypercard	The Macintosh Hypercard: info & uses.
comp.sys.mac.programmer	Discussion by people programming the Apple Macintosh.
comp.sys.masscomp	The Masscomp line of computers. (Moderated)
comp.sys.misc		Discussion about computers of all kinds.
comp.sys.next		Discussion about the new NeXT computer.
comp.sys.nsc.32k	National Semiconductor 32000 series chips.
comp.sys.proteon	Proteon gateway products.
comp.sys.pyramid	Pyramid 90x computers.
comp.sys.ridge		Ridge 32 computers and ROS. 
comp.sys.sequent	Sequent systems, (Balance and Symmetry).
comp.sys.sgi		Silicon Graphics's Iris workstations and software.
comp.sys.sun		Sun "workstation" computers. (Moderated)
comp.sys.tahoe		CCI 6/32, Harris HCX/7, & Sperry 7000 computers.
comp.sys.tandy		Discussion about TRS-80's.
comp.sys.ti		Discussion about Texas Instruments.
comp.sys.transputer	The Transputer computer and OCCAM language.
comp.sys.workstations	Various workstation-type computers. (Moderated)
comp.sys.xerox		Xerox 1100 workstations and protocols.
comp.sys.zenith.z100	The Zenith Z-100 (Heath H-100) family of computers.
comp.terminals		All sorts of terminals.
comp.text		Text processing issues and methods.
comp.text.desktop	Technology & techniques of desktop publishing.
comp.theory.info-retrieval	Information Retrieval topics. (Moderated)
comp.unix		Discussion of UNIX* features and bugs. (Moderated)
comp.unix.aux		The version of UNIX for Apple Macintosh II computers.
comp.unix.i386		Versions of Unix running on Intel 80386-based boxes.
comp.unix.microport	Discussion of Microport's UNIX.
comp.unix.questions	UNIX neophytes group.
comp.unix.ultrix	Discussions about DEC's Ultrix.
comp.unix.wizards	Discussions, bug reports, and fixes on and for UNIX.
comp.unix.xenix		Discussion about the Xenix OS.
comp.windows.misc	Various issues about windowing systems.
comp.windows.ms		Window systems under MS/DOS.
comp.windows.news	Sun Microsystems' NewS window system.
comp.windows.x		Discussion about the X Window System.
comp.virus		Computer viruses & security. (Moderated)

misc.consumers		Consumer interests, product reviews, etc.
misc.consumers.house	Discussion about owning and maintaining a house.
misc.forsale		Short, tasteful postings about items for sale.
misc.handicap		Items of interest for/about the handicapped. (Moderated)
misc.headlines		Current interest: drug testing, terrorism, etc.
misc.invest		Investments and the handling of money.
misc.jobs.misc		Discussion about employment, workplaces, careers.
misc.jobs.offered	Announcements of positions available.
misc.jobs.resumes	Postings of resumes and "situation wanted" articles.
misc.kids		Children, their behavior and activities.
misc.legal		Legalities and the ethics of law.
misc.misc		Various discussions not fitting in any other group.
misc.security		Security in general, not just computers. (Moderated)
misc.taxes		Tax laws and advice.
misc.test		For testing of network software.  Very boring.
misc.wanted		Requests for things that are needed (NOT software).

news.admin		Comments directed to news administrators.
news.announce.conferences	Calls for papers and conference announcements. (Moderated)
news.announce.important	General announcements of interest to all. (Moderated)
news.announce.newusers	Explanatory postings for new users. (Moderated)
news.config		Postings of system down times and interruptions.
news.groups		Discussions and lists of newsgroups.
news.lists		News-related statistics and lists. (Moderated)
news.misc		Discussions of USENET itself.
news.newsites		Postings of new site announcements.
news.software.b		Discussion about B-news-compatible software.
news.software.notes	Notesfile software from the Univ. of Illinois.
news.sysadmin		Comments directed to system administrators.

rec.arts.anime		Japanese animation fen discussion.
rec.arts.books		Books of all genres, and the publishing industry.
rec.arts.comics		Comic books and strips, graphic novels, sequential art.
rec.arts.drwho		Discussion about Dr. Who.
rec.arts.int-fiction	Discussions about interactive fiction.
rec.arts.misc		Discussions about the arts not in other groups.
rec.arts.movies		Discussions of movies and movie making.
rec.arts.movies.reviews	Reviews of movies. (Moderated)
rec.arts.poems		For the posting of poems.
rec.arts.sf-lovers	Science fiction lovers' newsgroup.
rec.arts.startrek	Star Trek, the TV shows and the movies.
rec.arts.tv		The boob tube, its history, and past and current shows.
rec.arts.tv.soaps	Postings about soap operas.
rec.arts.wobegon	"A Prairie Home Companion" radio show discussion.
rec.audio		High fidelity audio.
rec.autos		Automobiles, automotive products and laws.
rec.autos.sport		Discussion of organized, legal auto competitions.
rec.autos.tech		Technical aspects of automobiles, et. al.
rec.aviation		Aviation rules, means, and methods.
rec.backcountry		Activities in the Great Outdoors.
rec.bicycles		Bicycles, related products and laws.
rec.birds		Hobbyists interested in bird watching.
rec.boats		Hobbyists interested in boating.
rec.equestrian		Discussion of things equestrian.
rec.folk-dancing	Folk dances, dancers, and dancing.
rec.food.cooking	Food, cooking, cookbooks, and recipes.
rec.food.drink		Wines and spirits.
rec.food.veg		Vegetarians.
rec.games.board		Discussion and hints on board games.
rec.games.bridge	Hobbyists interested in bridge.
rec.games.chess		Chess & computer chess.
rec.games.empire	Discussion and hints about Empire.
rec.games.frp		Discussion about Fantasy Role Playing games.
rec.games.go		Discussion about Go.
rec.games.hack		Discussion, hints, etc. about the Hack game.
rec.games.misc		Games and computer games.
rec.games.moria		Comments, hints, and info about the Moria game.
rec.games.pbm		Discussion about Play by Mail games.
rec.games.programmer	Discussion of adventure game programming.
rec.games.rogue		Discussion and hints about Rogue.
rec.games.trivia	Discussion about trivia.
rec.games.video		Discussion about video games.
rec.gardens		Gardening, methods and results.
rec.guns		Discussions about firearms. (Moderated)
rec.ham-radio		Amateur Radio practices, contests, events, rules, etc.
rec.ham-radio.packet	Discussion about packet radio setups.
rec.ham-radio.swap	Offers to trade and swap radio equipment.
rec.humor		Jokes and the like.  May be somewhat offensive.
rec.humor.d		Discussions on the content of rec.humor articles.
rec.humor.funny		Jokes that are funny (in the moderator's opinion).  (Moderated)
rec.mag			Magazine summaries, tables of contents, etc.
rec.mag.otherrealms	Edited science fiction & fantasy "magazine". (Moderated)
rec.misc		General topics about recreational/participant sports.
rec.models.rc		Radio-controlled models for hobbyists.
rec.motorcycles		Motorcycles and related products and laws.
rec.music.beatles	Postings about the Fab Four & their music.
rec.music.bluenote	Discussion of jazz, blues, and related types of music.
rec.music.cd		CDs -- availability and other discussions.
rec.music.classical	Discussion about classical music.
rec.music.dementia	Discussion of comedy and novelty music.
rec.music.folk		Folks discussing folk music of various sorts.
rec.music.gaffa		Progressive music (e.g., Kate Bush). (Moderated)
rec.music.gdead		A group for (Grateful) Dead-heads.
rec.music.makers	For performers and their discussions.
rec.music.misc		Music lovers' group.
rec.music.newage	"New Age" music discussions.
rec.music.synth		Synthesizers and computer music.
rec.nude		Hobbyists interested in naturist/nudist activities.
rec.pets		Pets, pet care, and household animals in general.
rec.photo		Hobbyists interested in photography.
rec.puzzles		Puzzles, problems, and quizzes.
rec.railroad		Real and model train fans' newsgroup.
rec.scuba		Hobbyists interested in SCUBA diving.
rec.skiing		Hobbyists interested in snow skiing.
rec.skydiving		Hobbyists interested in skydiving.
rec.sport.baseball	Discussion about baseball.
rec.sport.basketball	Discussion about basketball.
rec.sport.football	Discussion about football.
rec.sport.hockey	Discussion about hockey.
rec.sport.misc		Spectator sports.
rec.travel		Traveling all over the world.
rec.video		Video and video components.
rec.woodworking		Hobbyists interested in woodworking.

sci.astro		Astronomy discussions and information.
sci.bio			Biology and related sciences.
sci.chem		Chemistry and related sciences.
sci.crypt		Different methods of data en/decryption.
sci.edu			Science education.
sci.electronics		Circuits, theory, electrons and discussions.
sci.environment		Discussions about the environment and ecology.
sci.lang		Natural languages, communication, etc.
sci.lang.japan		The Japanese language, both spoken and written.
sci.logic		Logic -- math, philosophy & computational aspects.
sci.math		Mathematical discussions and pursuits.
sci.math.stat		Statistics discussion.
sci.math.symbolic	Symbolic algebra discussion.
sci.med			Medicine and its related products and regulations.
sci.med.aids		AIDS: treatment, pathology/biology of HIV, prevention. (Moderated)
sci.med.physics		Issues of physics in medical testing/care.
sci.military		Discussion about science & the military. (Moderated)
sci.misc		Short-lived discussions on subjects in the sciences.
sci.nanotech		Self-reproducing molecular-scale machines. (Moderated)
sci.philosophy.tech	Technical philosophy: math, science, logic, etc. 
sci.physics		Physical laws, properties, etc.
sci.physics.fusion	Info on fusion, esp. "cold" fusion.
sci.psychology		Topics related to psychology.
sci.research		Research methods, funding, ethics, and whatever.
sci.space		Space, space programs, space related research, etc.
sci.space.shuttle	The space shuttle and the STS program.

soc.college		College, college activities, campus life, etc.
soc.couples		Discussions for couples (cf. soc.singles).
soc.culture.african	Discussions about Africa & things African.
soc.culture.arabic	Technological & cultural issues, *not* politics.
soc.culture.asian.american	Issues & discussion about Asian-Americans.
soc.culture.china	About China and Chinese culture.
soc.culture.celtic	Group about Celts (*not* basketball!).
soc.culture.greek	Group about Greeks.
soc.culture.indian	Group for discussion about India & things Indian.
soc.culture.japan	Everything Japanese, except the Japanese language.
soc.culture.jewish	Jewish culture & religion. (cf. talk.politics.mideast)
soc.culture.misc	Group for discussion about other cultures.
soc.culture.turkish	Discussion about things Turkish.
soc.feminism		Discussion of feminism & feminist issues. (Moderated)
soc.human-nets		Computer aided communications digest. (Moderated)
soc.men			Issues related to men, their problems & relationships.
soc.misc		Socially-oriented topics not in other groups.
soc.motss		Issues pertaining to homosexuality.
soc.net-people		Announcements, requests, etc. about people on the net.
soc.politics		Political problems, systems, solutions. (Moderated)
soc.politics.arms-d	Arms discussion digest. (Moderated)
soc.religion.christian	Christianity and related topics. (Moderated)
soc.roots		Genealogical matters.
soc.singles		Newsgroup for single people, their activities, etc.
soc.women		Issues related to women, their problems & relationships.

talk.abortion		All sorts of discussions and arguments on abortion.
talk.bizarre		The unusual, bizarre, curious, and often stupid.
talk.origins		Evolution versus creationism (sometimes hot!).
talk.philosophy.misc	Philosophical musings on all topics.
talk.politics.guns	The politics of firearm ownership and (mis)use.
talk.politics.mideast	Discussion & debate over Middle Eastern events.
talk.politics.misc	Political discussions and ravings of all kinds.
talk.politics.soviet	Discussion of Soviet politics, domestic and foreign.
talk.politics.theory	Theory of politics and political systems.
talk.religion.misc	Religious, ethical, & moral implications.
talk.religion.newage	Esoteric and minority religions & philosophies.
talk.rumors		For the posting of rumors.

--------------------
* UNIX is a registered Trademark of AT&T.
* DEC and Ultrix are Trademarks of the Digital Equipment Corporation.
* VAX is a Trademark of the Digital Equipment Corporation.
* Ada is a registered Trademark of the Ada Joint Program Office of the
   United States Department of Defense.
