From: spaf@cs.purdue.EDU (Gene Spafford)
Newsgroups: news.announce.newusers
Subject: A Primer on How to Work With the Usenet Community (Updated: 10 October 1988)
Message-ID: <5057@medusa.cs.purdue.edu>
Date: 11 Oct 88 02:55:15 GMT
Expires: +90days
Organization: Dept. of Computer Sciences, Purdue Univ.
Lines: 290
Approved: spaf@cs.purdue.EDU
Supersedes: <4837@medusa.cs.purdue.edu>

Original-from: chuq@sun.COM (Chuq Von Rospach)
[Most recent change: 19 June 1989 by spaf@cs.purdue.edu (Gene Spafford)]


              A Primer on How to Work With the USENET Community
                             Chuq Von Rospach 



  *** You now have access to Usenet, a  network of thousands of
  computers.  Other documents or your system administrator will provide
  detailed technical documentation.  This message describes the Usenet
  culture and customs that have developed over time.  All new users should
  read this message to find out how Usenet works. ***
  *** (Old users could read it, too, to refresh their memories.)  ***

  USENET is a large collection of computers that share data with each
  other.  It is the people on these computers that make USENET worth
  the effort to read and maintain, and for USENET to function properly
  those people must be able to interact in productive ways.  This
  document is intended as a guide to using the net in ways that will
  be pleasant and productive for everyone.

  This document is not intended to teach you how to use USENET.  Instead, it
  is a guide to using it politely, effectively and efficiently.
  Communication by computer is new to almost everybody, and there are
  certain aspects that can make it a frustrating experience until you get
  used to them.  This document should help you avoid the worst traps.

  The easiest way to learn how to use USENET is to watch how others use it.
  Start reading the news and try to figure out what people are doing and
  why.  After a couple of weeks you will start understanding why certain
  things are done and what things shouldn't be done.  There are documents
  available describing the technical details of how to use the software.
  These are different depending on which programs you use to access the
  news.  You can get copies of these from your system administrator.  If you
  do not know who that person is, they can be contacted on most systems by
  mailing to account "usenet".


           Never Forget that the Person on the Other Side is Human

  Because your interaction with the network is through a computer it is easy
  to forget that there are people "out there." Situations arise where
  emotions erupt into a verbal free-for-all that can lead to hurt feelings.

  Please remember that people all over the world are reading your words.  Do
  not attack people if you cannot persuade them with your presentation of
  the facts.  Screaming, cursing, and abusing others only serves to make
  people think less of you and less willing to help you when you need it.

  If you are upset at something or someone, wait until you have had a chance
  to calm down and think about it.  A cup of coffee or a good night's sleep
  works wonders on your perspective.  Hasty words create more problems than
  they solve.  Try not to say anything to others you would not say to them
  in person in a room full of people.

		 Be Careful What You Say About Others

  Please remember -- you read netnews; so do as many as 250,000 other
  people.  This group quite possibly includes your boss, your friend's
  boss, your girl friend's brother's best friend and one of your
  father's beer buddies.  Information posted on the net can come back
  to haunt you or the person you are talking about.

  Think twice before you post personal information about yourself or
  others.  This applies especially strongly to groups like soc.singles
  and alt.sex but even postings in groups like talk.politics.misc have
  included information about the personal life of third parties that
  could get them into serious trouble if it got into the wrong hands.

                                   Be Brief

  Never say in ten words what you can say in fewer.  Say it succinctly and
  it will have a greater impact.  Remember that the longer you make your
  article, the fewer people will bother to read it.  

               Your Postings Reflect Upon You -- Be Proud of Them

  Most people on USENET will know you only by what you say and how well you
  say it.  They may someday be your co-workers or friends.  Take some time
  to make sure each posting is something that will not embarrass you later.
  Minimize your spelling errors and make sure that the article is easy to
  read and understand.  Writing is an art and to do it well requires
  practice.  Since much of how people judge you on the net is based on your
  writing, such time is well spent.

                            Use Descriptive Titles

  The subject line of an article is there to enable a person with a limited
  amount of time to decide whether or not to read your article.  Tell people
  what the article is about before they read it.  A title like "Car for
  Sale" to rec.autos does not help as much as "66 MG Midget for sale:
  Beaverton OR." Don't expect people to read your article to find out what
  it is about because many of them won't bother.  Some sites truncate the
  length of the subject line to 40 characters so keep your subjects short
  and to the point.

                          Think About Your Audience

  When you post an article, think about the people you are trying to
  reach.  Asking UNIX(*) questions on rec.autos will not reach as many
  of the people you want to reach as if you asked them on
  comp.unix.questions or comp.unix.wizards.  Try to get the most
  appropriate audience for your message, not the widest.

  It is considered bad form to post both to misc.misc, soc.net-people,
  or misc.wanted and to some other newsgroup.  If it belongs in that
  other newsgroup, it does not belong in misc.misc, soc.net-people,
  or misc.wanted.  

  If your message is of interest to a limited geographic area (apartments,
  car sales, meetings, concerts, etc...), restrict the distribution of the
  message to your local area.  Some areas have special newsgroups with
  geographical limitations, and the recent versions of the news software
  allow you to limit the distribution of material sent to world-wide
  newsgroups.  Check with your system administrator to see what newsgroups
  are available and how to use them.

  If you want to try a test of something, do not use a world-wide newsgroup!
  Messages in misc.misc that say "This is a test" are likely to cause
  large numbers of caustic messages to flow into your mailbox.  There are
  newsgroups that are local to your computer or area that should be used.
  Your system administrator can tell you what they are.  

  Be familiar with the group you are posting to before you post!  You 
  shouldn't post to groups you do not read, or post to groups you've
  only read a few articles from -- you may not be familiar with the on-going
  conventions and themes of the group.  One normally does not join
  a conversation by just walking up and talking.  Instead, you listen
  first and then join in if you have something pertinent to contribute.

                      Be Careful with Humor and Sarcasm

  Without the voice inflections and body language of personal
  communications, it is easy for a remark meant to be funny to be
  misinterpreted.  Subtle humor tends to get lost, so take steps to make
  sure that people realize you are trying to be funny.  The net has
  developed a symbol called the smiley face.  It looks like ":-)" and points
  out sections of articles with humorous intent.  No matter how broad the
  humor or satire, it is safer to remind people that you are being funny.

  But also be aware that quite frequently satire is posted without any
  explicit indications.  If an article outrages you strongly, you
  should ask yourself if it just may have been unmarked satire.
  Several self-proclaimed connoisseurs refuse to use smiley faces, so
  take heed or you may make a temporary fool of yourself.

                           Only Post a Message Once

  Avoid posting messages to more than one newsgroup unless you are sure
  it is appropriate.  If you do post to multiple newsgroups, do not
  post to each group separately.  Instead, specify all the groups on a
  single copy of the message.  This reduces network overhead and lets
  people who subscribe to more than one of those groups see the message
  once instead of having to wade through each copy.

               Please Rotate Messages With Questionable Content

  Certain newsgroups (such as rec.humor) have messages in them that may
  be offensive to some people.  To make sure that these messages are
  not read unless they are explicitly requested, these messages should
  be encrypted.  The standard encryption method is to rotate each
  letter by thirteen characters so that an "a" becomes an "n".  This is
  known on the network as "rot13" and when you rotate a message the
  word "rot13" should be in the "Subject:" line.  Most of the software
  used to read usenet articles have some way of encrypting and
  decrypting messages.  Your system administrator can tell you how the
  software on your system works, or you can use the Unix command "tr
  [a-z][A-Z] [n-z][a-m][N-Z][A-M]". (Note that some versions of Unix
  don't require the [] in the "tr" command.  In fact, some systems will
  get upset if you use them in an unquoted manner.  The following
  should work for everyone, but may be shortened on some systems:
	tr '[a-m][n-z][A-M][N-Z]' '[n-z][a-m][N-Z][A-M]'
  Don't forget the single quotes!)

                     Summarize What You are Following Up

  When you are following up someone's article, please summarize the parts of
  the article to which you are responding.  This allows readers to
  appreciate your comments rather than trying to remember what the original
  article said.  It is also possible for your response to get to some sites
  before the original article.

  Summarization is best done by including appropriate quotes from the
  original article.  Do not include the entire article since it will
  irritate the people who have already seen it.  Even if you are responding
  to the entire article, summarize only the major points you are discussing.

                         When Summarizing, Summarize!

  When you request information from the network, it is common courtesy to
  report your findings so that others can benefit as well.  The best way of
  doing this is to take all the responses that you received and edit them
  into a single article that is posted to the places where you originally
  posted your question.  Take the time to strip headers, combine duplicate
  information, and write a short summary.  Try to credit the information to
  the people that sent it to you, where possible.

                       Use Mail, Don't Post a Follow-up

  One of the biggest problems we have on the network is that when someone
  asks a question, many people send out identical answers.  When this
  happens, dozens of identical answers pour through the net.  Mail your
  answer to the person and suggest that they summarize to the network.  This
  way the net will only see a single copy of the answers, no matter how many
  people answer the question.

  If you post a question, please remind people to send you the answers by
  mail and offer to summarize them to the network.

       Read All Follow-ups and Don't Repeat What Has Already Been Said

  Before you submit a follow-up to a message, read the rest of the messages
  in the newsgroup to see whether someone has already said what you want to
  say.  If someone has, don't repeat it.

		 Check the Headers When Following Up
  
  The news software has provisions to specify that follow-ups to an
  article should go to a specific set of newsgroups -- possibly
  different from the newsgroups to which the original article was
  posted.  Sometimes the groups chosen for follow-ups are totally
  inappropriate, especially as a thread of discussion changes with
  repeated postings.  You should carefully check the groups and
  distributions given in the header and edit them as appropriate.  If
  you change the groups named in the header, or if you direct
  follow-ups to a particular group, say so in the body of the message
  -- not everyone reads the headers of postings.


                   Be Careful About Copyrights and Licenses

  Once something is posted onto the network, it is effectively in the
  public domain unless you own the appropriate rights (most notably,
  if you wrote the thing yourself) and you post it with a valid
  copyright notice.  Of course, the *information* becomes public, so
  you mustn't post trade secrets that way.  When posting material to
  the network, keep in mind that material that is UNIX-related may be
  restricted by the license you or your company signed with AT&T and
  be careful not to violate it.  You should also be aware that posting
  movie reviews, song lyrics, or anything else published under a
  copyright could cause you, your company, or the net itself to be
  held liable for damages, so we highly recommend caution in using
  this material.

                         Cite Appropriate References

  If you are using facts to support a cause, state where they came from.
  Don't take someone else's ideas and use them as your own.  You don't want
  someone pretending that your ideas are theirs; show them the same respect.

                     Mark or Rotate Answers and Spoilers

  When you post something (like a movie review that discusses a detail of
  the plot) which might spoil a surprise for other people, please mark your
  message with a warning so that they can skip the message.  Another
  alternative would be to use the "rot13" protocol to encrypt the message so
  it cannot be read accidentally.  When you post a message with a spoiler in
  it make sure the word "spoiler" is part of the "Subject:" line.

                      Spelling Flames Considered Harmful

  Every few months a plague descends on USENET called the spelling flame.
  It starts out when someone posts an article correcting the spelling or
  grammar in some article.  The immediate result seems to be for everyone on
  the net to turn into a 6th grade English teacher and pick apart each other's
  postings for a few weeks.  This is not productive and tends to cause
  people who used to be friends to get angry with each other.

  It is important to remember that we all make mistakes, and that there are
  many users on the net who use English as a second language.  If you feel
  that you must make a comment on the quality of a posting, please do so by
  mail, not on the network.

                           Don't Overdo Signatures

  Signatures are nice, and many people can have a signature added to
  their postings automatically by placing it in a file called
  "$HOME/.signature".  Don't overdo it.  Signatures can tell the world
  something about you, but keep them short.  A signature that is longer
  than the message itself is considered to be in bad taste.  The main
  purpose of a signature is to help people locate you, not to tell your
  life story.  Every signature should include at least your return
  address relative to a well known site on the network and/or a proper
  domain-format address.   Your system administrator can give this to
  you.  Some news posters attempt to enforce a 4 line limit on
  signature files -- an amount that should be more than sufficient to
  provide a return address and attribution.


                        Summary of Things to Remember


       Never forget that the person on the other side is human
       Be Careful What You Say About Others
       Be brief
       Your postings reflect upon you; be proud of them
       Use descriptive titles
       Think about your audience
       Be careful with humor and sarcasm
       Only post a message once
       Please rotate material with questionable content
       Summarize what you are following up
       Use mail, don't post a follow-up
       Read all follow-ups and don't repeat what has already been said
       Double-check follow-up newsgroups and distributions.
       Be careful about copyrights and licenses
       Cite appropriate references
       When summarizing, summarize
       Mark or rotate answers or spoilers
       Spelling flames considered harmful
       Don't overdo signatures


(*)UNIX is a registered trademark of AT&T.

-----------
      This document is in the public domain and may be reproduced or
      excerpted by anyone wishing to do so.
