From: spaf@cs.purdue.EDU (Gene Spafford)
Newsgroups: news.lists,news.groups,news.announce.newusers
Subject: List of Moderators (Updated: 23 August 1988)
Message-ID: <5064@medusa.cs.purdue.edu>
Date: 11 Oct 88 02:56:01 GMT
Expires: +90days
Organization: Dept. of Computer Sciences, Purdue Univ.
Lines: 305
Approved: spaf@cs.purdue.EDU
Supersedes: <4844@medusa.cs.purdue.edu>
Xref: rice news.lists:259 news.groups:3608 news.announce.newusers:185

Original-from: Gene Spafford (spaf@cs.purdue.edu)
[Most recent change: 19 June 1989 by spaf@cs.purdue.edu (Gene Spafford)]

A number of moderated groups exist on the net.  These are groups which
usually have one or more individuals (acting as editors and/or
moderators) who must approve articles before they are published to the
net.  In general, these groups fall into one of five categories:

1) Groups with postings of an informative nature not suited to
   discussion and always originating from the same (very small) group
   of posters.  Groups within this category include news.lists,
   news.announce.newusers, and comp.mail.maps.

2) Groups derived from regular groups with such a high volume that
   it is hard for the average reader to keep up.  The moderated
   versions of these groups are an attempt to provide a lower volume
   and higher quality version of the same forum.  Examples of
   this category include news.announce and comp.unix.

3) Groups derived from regular groups which have often been abused.
   That is, the regular groups often received postings of items which
   were not germane to the stated topic of the group (or sometimes even
   within the realm of politeness for the net).  This also includes
   groups suffering from an annoying number of duplicate postings and
   inappropriate followups.  Moderated groups in this category include
   comp.sources.unix.

4) Groups designed to serve also as direct feedback to an off-the-net
   group.  The discussion in comp.std.mumps is an example of this.

5) Groups which are gatewayed into the Usenet from an Arpa Internet
   mailing list.  These groups are moderated by someone on the Internet
   side but are shared with the Usenet population.  Submissions mailed
   to the proper addresses, given below, will appear in both the group
   on Usenet, and the Internet list.  This includes some groups in
   the "inet" distribution which are listed here for completeness:
   comp.ai.vision, comp.lang.clu and rec.mag.fsfnet.

To post to a moderated group, write your article and mail it to the
listed SUBMISSION address.  The moderator will then do the actual
posting of the article.  The news software on the Usenet will not allow
direct posting to moderated newsgroups, nor will it forward
unauthorized articles to other sites.  The only way to post to a
moderated group is to mail it to the moderator.  If you are running
2.11 news or later, your news software will automatically mail your
article to the moderator if you attempt to post it.  Thus, posting to a
moderated newsgroup should appear the same as posting to any other
group (except you don't see the posting right away).

Depending on the newsgroup involved, if the moderator feels that your
article is inappropriate for the group, s/he will return the article to
you with a suggestion for other newsgroups in which to post it, and/or
an explanation of why it is not appropriate for the moderated group.
You may still post such articles to the regular groups as you currently
do, if such groups exist.

If you have questions or complaints about the way a moderated group is
run, contact the moderator by mail.  Alternatively, you can send mail
to the mailing list "moderators@purdue.edu" and it will be rebroadcast
to all of the current Usenet-only newsgroup moderators.

Below is a list of the current moderated groups and the moderators of
those groups. Included in that list are the addresses to use if you
have questions of comments about the groups. After that is given a list
of addresses for submissions of articles to those groups. If your site
is running 2.10.2 or 2.10.3 news, these addresses can be used to build
the "moderators" file so that "postnews" can automatically mail an
article to the correct moderator. 

If your system is running 2.11 news, posting to moderated newsgroups
is done by mailing your submission to well-defined aliases at a nearby
well-connected site.  The mail path to that site should be in your
news library, in the file "mailpaths" -- there is no need to update
a moderators file.  Information on how to construct the paths in the
"mailpaths" file are posted monthly in a companion article.

If you are NOT running 2.11 news, you are *STRONGLY* advised to upgrade
to it so as to take advantage of this feature, as well as the numerous
bug fixes and other enhancements.  

The addresses below are given in Internet/domain form.  If a site has
an Internet address, that is given in the list, otherwise a UUCP
pseudo-domain address is given.  If you are a UUCP-only site, you can
mail to an ARPA (EDU, GOV, etc.)-only site by mailing through the
gateways using a uucp-style path, e.g.:
	...!{clyde,decuac,mcnc,ucsd,uw-beaver,watmath}!site.arpa!address

Gene Spafford 
10 October 1988
------------------------------------------------------------------
Group			
	Moderator or Coordinator	Requests, Comments, etc.
------------------------------------------------------------------
comp.ai.digest 
	Kenneth Laws		ailist-request@stripe.sri.com
comp.ai.nlang-know-rep
	Christopher Welty	nl-kr-request@cs.rpi.edu
comp.ai.shells
	Bernd Bachmann		shellreq@uklirb.uucp
comp.ai.vision
	Tod Levitt		vision-list-request@ads.com
comp.archives
	T. William Wells	comp-archives-request@twwells.uucp
comp.binaries.amiga 
	Bob Page 		page@sun.com
comp.binaries.atari.st 
	Steven Grimm		atari-binaries@ssyx.ucsc.edu
comp.binaries.ibm.pc
	Rahul Dhesi		ibmpc-binaries-request@bsu-cs.bsu.edu
comp.binaries.mac 
	Roger Long		macintosh-request@felix.uucp
comp.bugs.4bsd.ucb-fixes 
	Keith Bostic		ucb-fixes-request@okeeffe.berkeley.edu
comp.compilers 
	John Levine		compilers-request@ima.isc.com
comp.dcom.telecom 
	Patrick Townson		telecom-request@eecs.nwu.edu
comp.doc 
	Brian Kantor		comp-doc@ucsd.edu
comp.doc.techreports 
	Lawrence Leff		trlist-request@cs.smu.edu
comp.graphics.digest 
	Andy Cromarty		info-graphics-request@ads.com
comp.lang.clu
	Matti Jokinen		clu-sw-request@cs.utu.fi
comp.lang.sigplan
	David S. Wise		sigplan-request@iuvax.cs.indiana.edu
comp.laser-printers 
	Richard Furuta		laser-lovers-request@brillig.umd.edu
comp.mail.maps
	Mel Pleasant		uucpmap@rutgers.edu
comp.newprod 
	Ron Heiby		newprod-request@mcdchg.chi.il.us
comp.org.fidonet 
	Tim Pozar		pozar@hop.toad.com
comp.os.research 
	Darrell Long		darrell@jupiter.ucsc.edu
comp.parallel
	Dennis Stevenson	hypercube-request@hubcap.clemson.edu
comp.protocols.kermit 
	Frank da Cruz		info-kermit-request@cu20b.columbia.edu
comp.risks 
	Peter G. Neumann	risks-request@csl.sri.com
comp.simulation
	Paul A. Fishwick	simulation-request@uflorida.cis.ufl.edu
comp.society 
	Dave Taylor		comp-soc-request@hplabs.hp.com
comp.society.women
	Trish Roberts		comp-women-request@cs.purdue.edu
comp.sources.amiga 
	Bob Page		page@sun.com
comp.sources.atari.st 
	Steven Grimm		atari-sources@ssyx.ucsc.edu
comp.sources.games 
	Bill Randle		games-request@saab.cna.tek.com
comp.sources.mac 
	Roger Long		macintosh-request@felix.uucp
comp.sources.misc
	Brandon S. Allbery	sources-misc-request@uunet.uu.net
comp.sources.sun
	Charles McGrew		mcgrew@aramis.rutgers.edu
comp.sources.unix 
	Rich Salz		rsalz@uunet.uu.net
comp.sources.x
	Dan Heller		argv@island.uu.net
comp.std.mumps 
	Hokey			std-mumps-request@plus5.com
comp.std.unix 
	John S. Quarterman	std-unix-request@uunet.uu.net
comp.sys.ibm.pc.digest 
	Gregory Hicks		info-ibmpc-request@simtel20.army.mil
comp.sys.m68k.pc
	Mike Meyer		info-68k-request@ucbvax.berkeley.edu
comp.sys.mac.digest 
	Lance Nakata, Jon Pugh, 
	    & Dwayne Virnau	info-mac-request@sumex-aim.stanford.edu
comp.sys.masscomp 
	Stan Barber		masscomp-request@soma.neuro.bcm.tmc.edu
comp.sys.sun 
	William LeFebvre	sun-spots-request@rice.edu
comp.sys.workstations 
	Dave Steiner		works-request@rutgers.edu
comp.theory.info-retrieval
	Edward A. Fox		fox@vtopus.cs.vt.edu
comp.unix 
	D. Tynan		comp-unix-req@zorba.tynan.com
comp.virus
	Kenneth van Wyk		virus-l@ubu.cc.lehigh.edu
misc.handicap 
	Bill McGarry		wtm@bunker.uucp
misc.security
	A. "*Hobbit*" Walker	security-request@rutgers.edu
news.announce.conferences 
	Dennis Page		denny@mcmi.uucp
news.announce.important 
	Mark Horton		announce@stargate.com
news.announce.newusers 
	Gene Spafford		spaf@purdue.edu
news.lists 
	Rick Adams, Brian Reid &
	   Gene Spafford	news-lists-request@cs.purdue.edu
rec.arts.movies.reviews 
	Evelyn C. Leeper	movies-request@mtgzy.att.com
rec.guns 
	Sean Sheedy		sean@ism780c.isc.com
rec.humor.funny
	Brad Templeton		funny-request@looking.uucp
rec.mag.fsfnet
	David Liscomb		csdave@maine.bitnet
rec.mag.otherrealms
	Chuq von Rospach	chuq@apple.com
rec.music.gaffa 
	Doug Alan		love-hounds-request@eddie.mit.edu
sci.med.aids
	Dan Greening		aids-request@cs.ucla.edu
sci.military
	Bill Thacker		military-request@att.att.com
sci.nanotech
	J. Storrs Hall (JoSH)	josh@aramis.rutgers.edu
soc.feminism
	Jean Marie Diaz, Valerie Maslak,
	  Miriam Nadel, & 
	  Cindy Tittle		feminism-request@ncar.ucar.edu
soc.human-nets 
	Charles McGrew		human-nets-request@rutgers.edu
soc.politics
	Charles McGrew		poli-sci-request@rutgers.edu
soc.politics.arms-d
	Herb Lin		arms-d-request@xx.lcs.mit.edu
soc.religion.christian 
	Charles Hedrick		christian-request@aramis.rutgers.edu
alt.gourmand
	Brian Reid		recipes-request@decwrl.dec.com
alt.sources.amiga
	Peter da Silva &
	    Karl Lehenbauer	amiga-sources@sugar.uu.net
gnu.announce
	Leonard H. Tower Jr.	info-gnu-request@prep.ai.mit.edu

------------------------------------------------------------------
Group				Submissions
:-----------------------------------------------------------------
comp.ai.digest			ailist@stripe.sri.com
comp.ai.nlang-know-rep		nl-kr@cs.rpi.edu
comp.ai.shells			shell@uklirb.uucp
comp.ai.vision			vision-list@ads.com
comp.archives			comp-archives@twwells.uucp
comp.binaries.amiga		page@sun.com
comp.binaries.atari.st		atari-binaries@ssyx.ucsc.edu
comp.binaries.ibm.pc		ibmpc-binaries@bsu-cs.bsu.edu
comp.binaries.mac		macintosh@felix.uucp
comp.bugs.4bsd.ucb-fixes	ucb-fixes@okeeffe.berkeley.edu
comp.compilers			compilers@ima.isc.com
comp.dcom.telecom		telecom@eecs.nwu.edu
comp.doc			comp-doc@ucsd.edu
comp.doc.techreports		trlist@cs.smu.edu
comp.graphics.digest		info-graphics@ads.com
comp.lang.clu			clu-sw@cs.utu.fi
comp.lang.sigplan		sigplan@iuvax.cs.indiana.edu
comp.laser-printers		laser-lovers@brillig.umd.edu
comp.mail.maps			uucpmap@rutgers.edu
comp.newprod			newprod@mcdchg.chi.il.us
comp.org.fidonet		pozar@hop.toad.com
comp.os.research		darrell@jupiter.ucsc.edu
comp.parallel			hypercube@hubcap.clemson.edu
comp.protocols.kermit		info-kermit@cu20b.columbia.edu
comp.risks			risks@csl.sri.com
comp.simulation			simulation@uflorida.cis.ufl.edu
comp.society			comp-soc@hplabs.hp.com
comp.sources.amiga		page@sun.com
comp.sources.atari.st		atari-sources@ssyx.ucsc.edu
comp.sources.games		games@saab.cna.tek.com
comp.sources.mac		macintosh@felix.uucp
comp.sources.misc		sources-misc@uunet.uu.net
comp.sources.sun		sun-sources@topaz.rutgers.edu
comp.sources.unix		rsalz@uunet.uu.net
comp.sources.x			x-sources@island.uu.net
comp.std.mumps			std-mumps@plus5.com
comp.std.unix			std-unix@uunet.uu.net
comp.sys.ibm.pc.digest		info-ibmpc@simtel20.army.mil
comp.sys.m68k.pc		info-68k@ucbvax.berkeley.edu
comp.sys.mac.digest		info-mac@sumex-aim.stanford.edu
comp.sys.masscomp		masscomp@soma.neuro.bcm.tmc.edu
comp.sys.sun			sun-spots@rice.edu
comp.sys.workstations		works@rutgers.edu
comp.theory.info-retrieval	fox@vtopus.cs.vt.edu
comp.unix			comp-unix@zorba.tynan.com
comp.virus			virus-l@ubu.cc.lehigh.edu
comp.society.women		comp-women@cs.purdue.edu
misc.handicap			handicap@bunker.uucp
misc.security			security@rutgers.edu
news.announce.conferences	news-announce-conferences@mcmi.uucp
news.announce.important		announce@stargate.com
news.announce.newusers		spaf@cs.purdue.edu
news.lists			news-lists-request@cs.purdue.edu
rec.arts.movies.reviews		movies@mtgzy.att.com
rec.guns			rec-guns@ism780c.isc.com
rec.humor.funny			funny@looking.uucp
rec.mag.fsfnet			csdave@maine.bitnet
rec.mag.otherrealms		chuq@apple.com
rec.music.gaffa			gaffa-post@eddie.mit.edu
sci.med.aids			aids@cs.ucla.edu
sci.military			military@att.att.com
sci.nanotech			nanotech@aramis.rutgers.edu
soc.feminism			feminism@ncar.ucar.edu
soc.human-nets			human-nets@red.rutgers.edu
soc.politics			poli-sci@rutgers.edu
soc.politics.arms-d		arms-d@xx.lcs.mit.edu
soc.religion.christian		christian@aramis.rutgers.edu
gnu.announce			info-gnu@prep.ai.mit.edu
alt.gourmand			recipes@decwrl.dec.com
alt.sources.amiga		amiga-sources@sugar.uu.net
ddn.mgt-bulletin		nic@sri-nic.arpa
comp.protocols.iso.x400		post-x400@tis.llnl.gov
comp.protocols.iso.x400.gateway	post-x400-gateway@tis.llnl.gov
