From: spaf@cs.purdue.EDU (Gene Spafford)
Newsgroups: news.announce.newusers
Subject: Hints on writing style for Usenet (Updated: 10 October 1988)
Message-ID: <5058@medusa.cs.purdue.edu>
Date: 11 Oct 88 02:55:21 GMT
Expires: +90days
Organization: Dept. of Computer Sciences, Purdue Univ.
Lines: 95
Approved: spaf@cs.purdue.EDU
Supersedes: <4838@medusa.cs.purdue.edu>

Original-from: ofut@gatech.edu (A. Jeff Offutt VI)
[Most recent change: 6 March 1989 by spaf@cs.purdue.edu (Gene Spafford)]

I would like to take a moment to share some of my knowledge of writing
style.  If you read the suggestions below, remember: it's easy to agree
that they make sense but it's much harder to apply them.

References: 
 Cunningham and Pearsall, "How to Write For the World of Work"
 Strunk & White, "Elements of Style"

The above references are both excellent books.  Cunningham is a
standard in tech writing classes and won an award for the best tech
writing book from the Association for Teaching of Technical Writing.  I
was lucky enough to take a class from him as an undergraduate.  Strunk
is a standard in college composition classes.  Other ideas here come
from my own experience on the net and hints from other people.

This is a "long article." The rest of it is simply a list of pointers.

               Writing style:

 * Write *below* the readers' reading level.  The avg. person in the US
   reads at a 5th grade level (11 years of age). The avg. professional
   reads at about the 12th grade level (18 years of age).

 * Keep paragraphs short and sweet.  Keep sentences shorter and sweeter. 
   This means "concise," not cryptic.

 * White space is not wasted space -- it greatly improves clarity.
   A blank line only adds a byte to the article length, so don't be
   stingy if it will help make your meaning clearer.

 * Pick your words to have only *one* meaning.  Vagueness is considered 
   artistic by literary critics.  We are not being literary here.

 * People can only grasp about seven things at once.  This means ideas in a
   paragraph, major sections, etc..

 * Avoid abbreviations and acronyms, if possible, and define the ones
   you use.

 * There are several variations on any one sentence.  A passive, questioning
   or negative sentence takes longer to read.


               Net style:

 * Subtlety is not communicated well in written form - especially over a 
   computer.

 * The above applies to humor as well. (rec.humor, of course, not included.)

 * When being especially "flame-boyant", I find it helpful to go to the bathroom
   before actually sending.  Then, I often change the tone considerably. :-)
   Take a break before posting something in anger or that might hurt or
   anger others.

 * Subject lines should be used very carefully.  How much time have you
   wasted reading articles with a misleading subject line?  The "Subject:"
   header line can be edited in all the various posting programs
   (as can the "Distribution:", "Newsgroups:" and "Followup-To:" header
   lines).

 * References need to be made.  When you answer mail, you have the original
   message fresh in your mind.  When I receive your answer, I don't.

 * It's *much* easier to read a mixture of upper and lower case letters.

 * Leaving out articles (such as "the," "a," "an," etc.) for "brevity"
   mangles the meaning of your sentences and takes longer to read. It saves
   you time at the expense of your reader.

 * Be careful of contextual meanings of words. For instance, I used "articles" 
   just now.  In the context of netnews, it has a different meaning than I 
   intended.

 * Make an effort to spell words correctly.  Obvious misspellings are
   jarring and distract the reader.  Every news posting program allows
   you to edit your article before posting, and most systems have some
   kind of spelling checker program that you can use on your article.

 * Remember - this is an international network.

 * Remember - your future employers may be reading your articles.

'Nuff said.  

These suggestions are all easily supported by arguments and research.
There's a lot more to say, but....
